﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.WebEdition;
using ThinkGeo.MapSuite.Core;

namespace MS_OSPFM
{
    public partial class DyanamicLabel : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                #region Set Map Properties and values
                string sUnit = "Meter";
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
                Map1.CurrentExtent = new RectangleShape(-13939426.6371, 6701997.4056, -7812401.86, 2626987.386962);
                Map1.MapTools.PanZoom.Enabled = false;
                Map1.MapTools.PanZoomBar.Enabled = true;
                Map1.MapUnit = (GeographyUnit)Enum.Parse(typeof(GeographyUnit), sUnit);

                LayerOverlay layerOverLay = new LayerOverlay("OSPFM Layers");
                layerOverLay.IsBaseOverlay = false;
                layerOverLay.ClientCache.CacheId = "OSPFM_Layers";
                layerOverLay.TransitionEffect = TransitionEffect.None;
                layerOverLay.TileType = TileType.SingleTile;
                layerOverLay.Layers.Clear();

                //# end of Map properties
                #endregion

                //3 - Load Buried_Cable.shp 
                ShapeFileFeatureLayer lyr_lines_Buried_Cable = new ShapeFileFeatureLayer(Server.MapPath("~/Data/Buried_Cable.shp"));
                lyr_lines_Buried_Cable.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.StandardColors.Blue, 1f, true);
                lyr_lines_Buried_Cable.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level15;
                lyr_lines_Buried_Cable.DrawingMarginPercentage = 50;

                Proj4Projection proj4_lines_Buried_Cable = new Proj4Projection();
                proj4_lines_Buried_Cable.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_lines_Buried_Cable.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                lyr_lines_Buried_Cable.FeatureSource.Projection = proj4_lines_Buried_Cable;

                //4 - Load Buried_Cable.shp - Label
                ShapeFileFeatureLayer lyr_lines_Buried_Cable_lbl = new ShapeFileFeatureLayer(Server.MapPath("~/Data/Buried_Cable.shp"));
                lyr_lines_Buried_Cable_lbl.ZoomLevelSet.ZoomLevel16.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.StandardColors.Blue, 1f, true);

                TextStyle textStyle = TextStyles.CreateSimpleTextStyle("LABEL", "Aerial", 15, DrawingFontStyles.Regular, GeoColor.StandardColors.Crimson, GeoColor.StandardColors.White, 5, 5, 10);
                textStyle.BestPlacement = true;
                textStyle.DuplicateRule = LabelDuplicateRule.UnlimitedDuplicateLabels;

                lyr_lines_Buried_Cable_lbl.ZoomLevelSet.ZoomLevel16.DefaultTextStyle = textStyle;
                lyr_lines_Buried_Cable_lbl.ZoomLevelSet.ZoomLevel16.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                lyr_lines_Buried_Cable_lbl.DrawingMarginPercentage = 50;

                Proj4Projection proj4_lines_Buried_Cable_lbl = new Proj4Projection();
                proj4_lines_Buried_Cable_lbl.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_lines_Buried_Cable_lbl.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                lyr_lines_Buried_Cable_lbl.FeatureSource.Projection = proj4_lines_Buried_Cable_lbl;

                //15 - Load Access_Point

                //16 - Load Aerial Cable

                layerOverLay.Layers.Add("Lyr_Buried_Cable", lyr_lines_Buried_Cable);
                layerOverLay.Layers.Add("lyr_lines_Buried_Cable_lbl", lyr_lines_Buried_Cable_lbl);
                

                VirtualEarthOverlay ve = new VirtualEarthOverlay("VirtualEarth Map");
                ve.VirtualEarthMapType = VirtualEarthMapType.Birdseye;

                Map1.CustomOverlays.Clear();
                Map1.CustomOverlays.Add(layerOverLay);
                Map1.CustomOverlays.Add(ve);
            }
        }
    }
}
